;;;;
;;;;	CLAUDIO RIVOIRA
;;;;
;;;;	c.rivoira@tiscalinet.it					(E-mail dedicata ad Autolisp)
;;;;
;;;;	http://digilander.libero.it/rivoira/index.html		(Sito dedicato alla Provincia di Cuneo)
;;;;
;
;  PER ACAD 12 o superiore   I T A L I A N O / I N G L E S E
;
;
;      ͻ
;                                                                   
;         ESTRAE I TESTI (NORMALI e MULTILINEA) DA UNA SELEZIONE    
;         E LI METTE IN ORDINE ALFABETICO                           
;                                                                   
;      ͼ
;
;
;---------------------------------
;  Input Variabili ambiente
;---------------------------------
(defun MODES (a)
   (setq mlst '())
   (repeat (length a)
      (setq mlst (append mlst (list (list (car a) (getvar (car a))))))
      (setq a (cdr a))
   )
)
;-----------------------------------
;  Ripristina variabili ambiente
;-----------------------------------
(defun MODER ()
   (repeat (length mlst)
      (setvar (caar mlst) (cadar mlst))
      (setq mlst (cdr mlst))
   )
)
; ----------------------------------
; Error handler (gestione errore)
; ----------------------------------
(defun b_err (st)
  (moder)						; Ripristina variabili memorizzate
  (setq *error* olderr)					; Restore old *error* handler

  (princ)						; Esce senza nil
)
;----------------------------
;        Input Dati
;----------------------------
(defun INDATI ()
;
   (graphscr)
   (setvar "highlight" 1)
   (setq colcor (getvar "cecolor"))			; Colore corrente
   (modes '("HIGHLIGHT" "OSMODE" "LIMCHECK" "CMDECHO"))
   (setvar "osmode" 0) (setvar "limcheck" 0)
   (setvar "cmdecho" 0)   
;
   (prompt "\nSeleziona la zona in cui ci sono testi da ordinare :")

; *************************************************************************************************
;		FILTRI DI SELEZIONE DELLE ENTITA' (VEDI TUTORIAL3.TXT)
; *************************************************************************************************
;
;;;   (setq sel(ssget))					; Seleziona le entita' (SENZA FILTRO)
  
   (setq sel(ssget					; Seleziona le entita' (CON FILTRO)
	      '((-4 . "<OR")
		(0 . "TEXT")				; Lascia passare solo le entita' TEXT
		(0 . "MTEXT")				; ... oppure le MTEXT (multilinea)
	       (-4 . "OR>"))
	    )
   )
; *************************************************************************************************
  
   (setq num (sslength sel))				; Numero entita selezionate
;
   (scorre sel num)					; Scorre tutta la selezione
;
)
;------------------------------------------------------------------------
;    Scorre tutta la selezione  per trovare i TEXT o gli MTEXT
;------------------------------------------------------------------------
(defun SCORRE (sel num)
   (setq tlst '())					; Inizializza la lista dei testi
   (setq indice 0 contatore 0)				; Inizializza l'indice e il contatore
   (repeat num
      (setq nome (ssname sel indice))			; Nome entita' esadecimale
      (setq ent (entget nome))				; Singola entita' (parola)
     
; *************************************************************************************************
;;;      (if (or 					; FILTRO (Vedi Tutorial3.txt)
;;;          (= (cdr (assoc 0 ent)) "TEXT")		; Lascia passare solo le entita' TEXT
;;;          (= (cdr (assoc 0 ent)) "MTEXT")		; ... oppure le MTEXT (multilinea)
;;;          )
;;;         (progn
; *************************************************************************************************
     
         (setq txt (cdr (assoc 1 ent)))			; Estrae il testo

         (if (= (cdr (assoc 0 ent)) "MTEXT")		; Se l'entita' e' un MTEXT ...
 		(spezzatxt txt)				; Salta a sub. SPEZZATXT ...
	        (setq tlst (append tlst (list txt)))	; ... Altrim. allunga la lista dei testi
         )
     
         (setq contatore (+ contatore 1))		; Aggiorna il contatore
     
; *************************************************************************************************
;;;         )						; Fine di progn
;;;      )						; Fine di IF (FILTRO)
; *************************************************************************************************
     
      (setq indice (+ indice 1))			; Aggiorna l'indice
   )							; Fine di Repeat NUM

)
;
;
;----------------------------
;      SPEZZA GLI MTEXT
;----------------------------
(defun SPEZZATXT (txt)
  (setq ind 1						; Inizializza l'indice
	strcar ""					; Inizializza la stringa carattere
  )
  (while (<= ind (strlen txt))				; Ripete fino a quando IND raggiunge lung. di TXT
    (setq carat (substr txt ind 1))			; Estrae l' "INDicesimo" carattere di TXT
    (setq acapo (substr txt ind 2))			; Estrae 2 carat. di TXT partendo dall'INDicesimo
    (if (= acapo "\\P")					; Se ACAPO = "\\P" (\\ e' un solo carattere) ...
      (progn
	(setq tlst (append tlst (list strcar)))		; ... Concatena la parola STRCAR alla lista tlst
	(setq strcar "")				; Riporta a "" la variabile STRCAR
	(setq ind (+ ind 2))				; Aggiorna l'indice (per oltrepassare \\P)
      )
      (progn
	(setq strcar (strcat strcar carat))		; ... Altrimenti allunga la stringa STRCAR
	(setq ind (+ ind 1))				; e aggiorna l'indice
      )
    )							; Fine di IF
  )							; Fine di WHILE
  (setq tlst (append tlst (list strcar)))		; Concatena ultima parola STRCAR alla lista tlst
)							; Fine di DEFUN
;
;
;
;----------------------------
;        PERCENTUALE
;----------------------------
(defun PERCENTUALE (indice num incremento)
;;
;; Indice	= e' un numero che viene incrementato prima di richiamare questa subrutine
;; Num		= Il numero totale da raggiungere (quando indice = num siamo al 100%)
;; Incremento	= Indica il passo con cui vengono visualizzate le percentuali: es.con un valore
;;		  10 vengono visualizzati i valori 10% - 20% - 30% ecc.
;;
;;	La formula di base e' 100 * indice / num ma per ottenere solo i valori stabiliti dalla
;;	variabile Incremento occorre dividere il risultato per Incremento, togliere (fix) le
;;	cifre dopo la virgola e rimoltiplicare per la variabile Incremento.
;;	Esempio con incremento = 10:
;;	In questo caso, le percentuali da 0% a 9% - da 11% a 19% ecc. ... non vengono visualizzate
;;	ma si attende di raggiungere un valore multiplo di 10 (10% 20% 30% ... ecc)
;;
      (setq perc (* (fix (/ (/ (* 100 indice) num) incremento)) incremento)); Trasforma in %
      (if (> perc perc1)(progn
         (prompt "\r")(prin1 perc)(prompt " %")		; Stampa a video la % di lavoro svolto
      )                 )
      (setq perc1 perc)					; Aggiorna record

      (if (and (> perc 100)(< (length tlst) 3))(setq indior nil))
;
)
;
;----------------------------------------------------------------------
;
;	O R D I N A M E N T O		(numerico o alfabetico)
;
;   Data una lista contenente una serie di parole o numeri
;   (in formato stringa) la riordina dal minore al maggiore
;----------------------------------------------------------------------
;
;  - -  Questa sub. necessita anche delle sub. CONTROLLA e PERCENTUALE - -
;
;  Sintassi di richiamo della subrutine:
;
;  (ORDINE LST STRNUM) in cui:
;		LST	= una lista di stringhe -> ("2" "aa" "03" "9G")
;		STRNUM	= flag numerico per indicare se la lista viene valutata come una
;			  lista di stringhe o una lista di numeri reali (estratti dalle stringhe)
;
; Se alla variabile STRNUM viene passato il valore 1, la lista verra' considerata composta
; da stringhe.
;
; ATTENZIONE:
; Se i numeri vengono valutati come stringhe, una lista verrebbe ordinata cosi':
; "1" "11" "12" "13" "2" "21" "22" "3" "31" "32" ecc.
; Anziche' :
; "1" "2" "3" "11" "12" "13" "21" "22" "31" "32"
;
; Se alla variabile STRNUM viene passato il valore 2, le stringhe della lista verranno trasformate in
; numeri reali (quindi verranno ordinati come nel secondo caso esposto qui sopra)
;
; Attenzione alla presenza di stringhe alfanumeriche nella lista: queste ultime, se vengono trasformate
; in numero reale, diventano = zero : (atof "aaa") = 0.0 e quindi verranno posizionate all'inizio
; della lista (prima del valore 1) e non ordinate.
; Le uniche strighe alfanumeriche che verranno considerate, saranno quelle che iniziano con un numero:
; (atof "9aaxt") = 9.0, che verranno ordinate prima o dopo un valore 9 numerico.
; Sempre per quanto riguarda le stringhe occorre ricordare che vengono valutate diversamente maiuscole
; e minuscole (case sensitive) quindi verrebbe ordinata una lista in questo modo:
; ("AAA" "Aaa" "BBB" "BBb" "BbB" "CCC" "CcC" "aaa" "bBb" "bbB" "bbb" "ccc")
;
; Conviene quindi utilizzare il valore 2 per STRNUM, solo se siamo sicuri NON VERRANNO SELEZIONATE
; DELLE STRINGHE ALFANUMERICHE.
;
(defun ORDINE (lst strnum)
;
  (setq orlst '())					; Inizializza la lista dei testi ordinati
  (setq flag T)						; Inizializza flag
;
  (setq indice 1)					; Indice per richiamo sub. percentuale
;;;
;;; Indior serve per verificare se avviene almeno uno scambio (se non avviene la lista e' ordinata)
;;; in questo modo e' possibile terminare prima il lavoro, tuttavia questo comporta l'impossibilita'
;;; di avere una percentuale di lavoro svolto affidabile (visualizzato sulla riga comando), come
;;; viene spiegato in una nota piu' in basso.
;;;
  (setq indior T)					; Indior = T (per entrare nel loop)
;
(while indior
  (setq indior nil)					; Indior = nil (ormai e' entrato nel loop)
;
;  - - - - - - - - - - - - - - - - - - - - - - - - - - -
  (if flag
    (progn
       (setq orlst '())					; Annulla orlst per riprendere l'ordinam.
       (setq flag nil)					; Riporta flag a nil (x il prossimo giro)
    )
    (progn
      (setq orlst (list (car lst)))			; orlst = al primo elemento di lst
      (setq lst (cdr lst))				; Accorcia di un elem. lst
      (setq flag T)					; Riporta flag a T (x il prossimo giro)
    )
  )
;  - - - - - - - - - - - - - - - - - - - - - - - - - - -
(while lst
  (if (= strnum 1)					; Se la lista e' considerata di STRINGHE
    (progn
      (setq primo (nth 0 lst))      			; Es.  "6"  -  Primo elemento
      (setq secondo (nth 1 lst))			; Es.  "2"  -  Secondo elemento
    )							; ... altrimenti ...
    (progn						; ... vengono estratti i numeri reali:
      (setq primo (atof (nth 0 lst)))      		; Es.  6.0  -  Primo elemento
      (setq secondo (atof (nth 1 lst)))			; Es.  2.0  -  Secondo elemento
    )
  )							; Fine di IF (= strnum 1)
;
  (if secondo
    (if (> primo secondo)					; Se il 1 elemento e' Magg. del 2...
	(progn
	     (controlla)				; Trasforma in stringhe primo e secondo
             (setq orlst (append orlst (list secondo)))	; Nella lista mette il 2 valore ("2")
             (setq orlst (append orlst (list primo)))	; ... e dopo ci mette il 1 valore ("6")
	     (setq indior T)				; Indior = T (e' avvenuto uno scambio)
	)						; ... altrimenti ...
    	(progn
	     (controlla)				; Trasforma in stringhe primo e secondo
             (setq orlst (append orlst (list primo)))	; ... Nella lista mette il primo valore
             (setq orlst (append orlst (list secondo)))	; ... e dopo ci mette il secondo valore
	)
    )							; Fine dell'IF (> primo secondo)
  )							; Fine di If Secondo
;
  (if (= (length lst) 2)				; Se lst ha solo 2 elem. (gia' da elabor.)
;
    (setq lst nil)					; Annulla variabile lst (per il loop)
;
    (progn
	(if (= (length lst) 3)				; Se lst ha 3 elem. (di cui 2 gia' elabor.)
	  (progn
	    (setq orlst (append orlst (list (nth 2 lst)))); Aggiunge a orlst l'ultimo el. disponib.
	    (setq lst nil)				; Annulla variabile lst (per il loop)
	  )
	  (setq lst (cdr (cdr lst)))			; Accorcia di 2 elementi la lista lst
	)						; Fine di IF
    )
  )							; Fine di IF
;
)							; Fine di while lst
;  - - - - - - - - - - - - - - - - - - - - - - - - - - -
;
  (setq indice (+ indice 1))				; Incrementa l'indice ...
  (percentuale indice contatore 5)			; ... ed aggiorna la percentuale a video.
;;;
;;;	Il calcolo della percentuale di lavoro svolto e' approssimativo, in quanto non e' possibile
;;;	stabilire fin dall'inizio quanti passaggi sono necessari per ordinare la lista: dipende da
;;;	quanto la lista di partenza e' disordinata. Per questo motivo, e' possibile che il lavoro
;;;	venga terminato prima che la percentuale visualizzata raggiunga 100 %.
;;;
;
  (setq lst orlst)					; aggiorna lst per ripetere il giro
)							; Fine di While indior
;
)							; Fine subrutine ORDINE
;
;-----------------------------------------------------------
;     Controlla se Primo e Secondo sono Reali o stringhe
;-----------------------------------------------------------
;
(defun controlla ()
;
   (if (= (type primo)(type "stringa"))			; Se PRIMO e' una stringa ...
    ()							; non fa nulla, altrimenti ...
    (progn
      (setq primo (nth 0 lst))      			; Ridefinisce PRIMO e SECONDO per trasf.
      (setq secondo (nth 1 lst))			; nuovamente in stringhe
    )
   )							; Fine di IF (= (type primo ...
)							; Fine della subrutine
;
;
;-----------------------------------
;     Elimina le stringhe "***"
;-----------------------------------
;
(defun depura (lst)
  (setq orlst '())					; Inizializza la variabile ORLST
  (while lst						; Fino a quando LST e' <> da nil ...
    (setq stringa (car lst))				; Estrae la prima stringa della lista
    (if (= stringa "***")()				; Se e' = a "***" non fa nulla ...
      (setq orlst (append orlst (list stringa)))	; Altrimenti la aggiunge a ORLST
    )							; Fine dell'IF
    (setq lst (cdr lst))				; Accorcia la lista LST (toglie 1 elemento)
  )							; Fine di While
)
;
;
;
;--------------------------------------------------
;     P R O G R A M M A     P R I N C I P A L E
;--------------------------------------------------
(defun C:TUTORIAL3 ()
;
   (setq olderr *error* *error* b_err)			; Richiama gestore errori
;
   (indati)						; Input dei dati
;
  (setq norlst tlst)					; Salva TLST in NORLST (lista non ordinata)
  (repeat 3						; Aggiunge a NORLST
    (setq norlst (append norlst '("***")))		; 3 stringhe "***"
  )
;
  (ordine norlst 1)					; Lista in ordine alfabetico
  (depura orlst)
  (setq alfabetico orlst)				; Salva lista ottenuta su nuova lista
;
  (ordine norlst 2)					; Lista in ordine numerico
  (depura orlst)
  (setq numerico orlst)					; Salva lista ottenuta su nuova lista
;
  (textscr)						; Passa allo schermo testo
;
  (prompt "\nLISTA NON ORDINATA :")
  (prompt "\ntlst = ")(prin1 tlst)
;
  (prompt "\n ")
  (prompt "\nLISTA ORDINATA (alfabetico):")
  (prompt "\n")(prin1 alfabetico)
;
  (prompt "\n ")
  (prompt "\nLISTA ORDINATA (numerico):")
  (prompt "\n")(prin1 numerico)
;
   (moder)						; Ripristina variabili iniziali
   (setq olderr *error*)				; Ripristina in caso di errore
; 
   (prin1)						; Esce senza nil
)
